// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringDao.vsl in andromda-spring-cartridge.
//
package fr.ifremer.adagio.core.dao.administration.user;

import fr.ifremer.adagio.core.dao.Search;
import fr.ifremer.adagio.core.dao.referential.Status;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.Set;
import org.andromda.spring.PaginationResult;

/**
 * Personne du référentiel (utilisateur ou non du système).
 * Nombre de lignes : 100
 * @see Person
 */
public interface PersonDao
{
    /**
     * This constant is used as a transformation flag; entities can be converted automatically into value objects
     * or other types, different methods in a class implementing this interface support this feature: look for
     * an <code>int</code> parameter called <code>transform</code>.
     * <p>
     * This specific flag denotes no transformation will occur.
     */
    public static final int TRANSFORM_NONE = 0;


    /**
     * Transforms the given results to a collection of {@link Person}
     * instances (this is useful when the returned results contains a row of data and you want just entities only).
     *
     * @param results the query results.
     */
    public void toEntities(final Collection<?> results);

    /**
     * Gets an instance of Person from the persistent store.
     * @param id
     * @return Person
     */
    public Person get(Integer id);

    /**
     * <p>
     * Does the same thing as {@link #get(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param id the identifier of the entity to get.
     * @return either the entity or the object transformed from the entity.
     */
    public Object get(int transform, Integer id);

    /**
     * Loads an instance of Person from the persistent store.
     * @param id
     * @return Person
     */
    public Person load(Integer id);

    /**
     * <p>
     * Does the same thing as {@link #load(Integer)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined in this class then the result <strong>WILL BE</strong> passed through an operation which can
     * optionally transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform flag to determine transformation type.
     * @param id the identifier of the entity to load.
     * @return either the entity or the object transformed from the entity.
     */
    public Object load(int transform, Integer id);

    /**
     * Loads all entities of type {@link Person}.
     *
     * @return the loaded entities.
     */
    public Collection<Person> loadAll();

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform);

    /**
     * <p>
     * Does the same thing as {@link #loadAll()} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int pageNumber, final int pageSize);

    /**
     * <p>
     * Does the same thing as {@link #loadAll(int)} with an
     * additional two arguments called <code>pageNumber</code> and <code>pageSize</code>. The <code>pageNumber</code>
     * argument allows you to specify the page number when you are paging the results and the pageSize allows you to specify the size of the
     * page retrieved.
     * </p>
     *
     * @param transform the flag indicating what transformation to use.
     * @param pageNumber the page number to retrieve when paging results.
     * @param pageSize the size of the page to retrieve when paging results.
     * @return the loaded entities.
     */
    public Collection<?> loadAll(final int transform, final int pageNumber, final int pageSize);

    /**
     * Creates an instance of Person and adds it to the persistent store.
     * @param person
     * @return Person
     */
    public Person create(Person person);

    /**
     * <p>
     * Does the same thing as {@link #create(Person)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param person
     * @return Object
     */
    public Object create(int transform, Person person);

    /**
     * Creates a new instance of Person and adds
     * from the passed in <code>entities</code> collection
     *
     * @param entities the collection of Person
     * instances to create.
     *
     * @return the created instances.
     */
    public Collection<Person> create(Collection<Person> entities);

    /**
     * <p>
     * Does the same thing as {@link #create(Person)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param entities
     * @return Collection
     */
    public Collection<?> create(int transform, Collection<Person> entities);

    /**
     * <p>
     * Creates a new <code>Person</code>
     * instance from <strong>all</strong> attributes and adds it to
     * the persistent store.
     * </p>
     * @param lastname 
     * @param firstname 
     * @param address 
     * @param creationDate 
     * @param phoneNumber 
     * @param mobileNumber 
     * @param faxNumber 
     * @param email 
     * @param updateDate 
     * @param cryptPassword Mot de passe crypté de l'utilisateur. Utilisé pour permettre une authentification meme en mode
déconnecté.
     * @param employeeNumber =code ou matricule de la personne. Valeur récupérée de l'annuaire LDAP.
Si la personne est un agent Ifremer, il s'agit de son numéro de matricule. Cela correspond alors à
l'attribut "employeenumber" dans l'annuaire LDAP (mais sans les zéros suplémentaires au début du
numéro).
Si la personne n'est pas Ifremer, un matricule sans signification lui est tout de même affecté :
toute personne, même extranet, a donc l'attribut "employeenumber" de renseigné dans l'annuaire LDAP.
     * @param username Login LDAP de l'utilisateur.
     * @param usernameExtranet 
     * @return Person
     */
    public Person create(
        String lastname,
        String firstname,
        String address,
        Date creationDate,
        String phoneNumber,
        String mobileNumber,
        String faxNumber,
        String email,
        Timestamp updateDate,
        String cryptPassword,
        String employeeNumber,
        String username,
        String usernameExtranet);

    /**
     * <p>
     * Does the same thing as {@link #create(String, String, String, Date, String, String, String, String, Timestamp, String, String, String, String)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform
     * @param lastname 
     * @param firstname 
     * @param address 
     * @param creationDate 
     * @param phoneNumber 
     * @param mobileNumber 
     * @param faxNumber 
     * @param email 
     * @param updateDate 
     * @param cryptPassword Mot de passe crypté de l'utilisateur. Utilisé pour permettre une authentification meme en mode
déconnecté.
     * @param employeeNumber =code ou matricule de la personne. Valeur récupérée de l'annuaire LDAP.
Si la personne est un agent Ifremer, il s'agit de son numéro de matricule. Cela correspond alors à
l'attribut "employeenumber" dans l'annuaire LDAP (mais sans les zéros suplémentaires au début du
numéro).
Si la personne n'est pas Ifremer, un matricule sans signification lui est tout de même affecté :
toute personne, même extranet, a donc l'attribut "employeenumber" de renseigné dans l'annuaire LDAP.
     * @param username Login LDAP de l'utilisateur.
     * @param usernameExtranet 
     * @return Person
     */
    public Object create(
        int transform,
        String lastname,
        String firstname,
        String address,
        Date creationDate,
        String phoneNumber,
        String mobileNumber,
        String faxNumber,
        String email,
        Timestamp updateDate,
        String cryptPassword,
        String employeeNumber,
        String username,
        String usernameExtranet);

    /**
     * <p>
     * Creates a new <code>Person</code>
     * instance from only <strong>required</strong> properties (attributes
     * and association ends) and adds it to the persistent store.
     * </p>
     * @param creationDate
     * @param department
     * @param firstname
     * @param lastname
     * @param status
     * @return Person
     */
    public Person create(
        Date creationDate,
        Department department,
        String firstname,
        String lastname,
        Status status);

    /**
     * <p>
     * Does the same thing as {@link #create(String, String, Date)} with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * the returned entity will <strong>NOT</strong> be transformed. If this flag is any of the other constants
     * defined here then the result <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entity (into a value object for example). By default, transformation does
     * not occur.
     * </p>
     * @param transform flag to determine transformation type.
     * @param creationDate
     * @param department
     * @param firstname
     * @param lastname
     * @param status
     * @return Object
     */
    public Object create(
        int transform,
        Date creationDate,
        Department department,
        String firstname,
        String lastname,
        Status status);

    /**
     * Updates the <code>person</code> instance in the persistent store.
     * @param person
     */
    public void update(Person person);

    /**
     * Updates all instances in the <code>entities</code> collection in the persistent store.
     * @param entities
     */
    public void update(Collection<Person> entities);

    /**
     * Removes the instance of Person from the persistent store.
     * @param person
     */
    public void remove(Person person);

    /**
     * Removes the instance of Person having the given
     * <code>identifier</code> from the persistent store.
     * @param id
     */
    public void remove(Integer id);

    /**
     * Removes all entities in the given <code>entities</code> collection.
     * @param entities
     */
    public void remove(Collection<Person> entities);


    /**
     * Does the same thing as {@link #search(int, Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param transform the transformation flag.
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int transform, final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional two flags called <code>pageNumber</code> and <code>pageSize</code>. These flags allow you to
     * limit your data to a specified page number and size.
     *
     * @param pageNumber the page number in the data to retrieve
     * @param pageSize the size of the page to retrieve.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search wrapped in a {@link PaginationResult} instance.
     */
    public PaginationResult search(final int pageNumber, final int pageSize, final Search search);

    /**
     * Does the same thing as {@link #search(Search)} but with an
     * additional flag called <code>transform</code>. If this flag is set to <code>TRANSFORM_NONE</code> then
     * finder results will <strong>NOT</strong> be transformed during retrieval.
     * If this flag is any of the other constants defined here
     * then results <strong>WILL BE</strong> passed through an operation which can optionally
     * transform the entities (into value objects for example). By default, transformation does
     * not occur.
     *
     * @param transform the transformation flag.
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<?> search(final int transform, final Search search);

    /**
     * Performs a search using the parameters specified in the given <code>search</code> object.
     *
     * @param search the search object which provides the search parameters and pagination specification.
     * @return any found results from the search.
     */
    public Set<Person> search(final Search search);

    /**
     * Allows transformation of entities into value objects
     * (or something else for that matter), when the <code>transform</code>
     * flag is set to one of the constants defined in <code>fr.ifremer.adagio.core.dao.administration.user.PersonDao</code>, please note
     * that the {@link #TRANSFORM_NONE} constant denotes no transformation, so the entity itself
     * will be returned.
     *
     * If the integer argument value is unknown {@link #TRANSFORM_NONE} is assumed.
     *
     * @param transform one of the constants declared in {@link fr.ifremer.adagio.core.dao.administration.user.PersonDao}
     * @param entity an entity that was found
     * @return the transformed entity (i.e. new value object, etc)
     * @see #transformEntities(int,Collection)
     */
    public Object transformEntity(final int transform, final Person entity);

    /**
     * Transforms a collection of entities using the
     * {@link #transformEntity(int,Person)}
     * method. This method does not instantiate a new collection.
     * <p>
     * This method is to be used internally only.
     *
     * @param transform one of the constants declared in <code>fr.ifremer.adagio.core.dao.administration.user.PersonDao</code>
     * @param entities the collection of entities to transform
     * @see #transformEntity(int,Person)
     */
    public void transformEntities(final int transform, final Collection<?> entities);

    // spring-dao merge-point
}